import { componentQrl, inlinedQrl, useLexicalScope, useRef, useStore, useWatchQrl, noSerialize, SkipRerender, implicit$FirstArg } from "@builder.io/qwik";
import { jsx, Fragment } from "@builder.io/qwik/jsx-runtime";
import { isBrowser, isServer } from "@builder.io/qwik/build";
function qwikifyQrl(reactCmp$, opts) {
  return /* @__PURE__ */ componentQrl(inlinedQrl((props) => {
    const [opts2, reactCmp$2] = useLexicalScope();
    const ref = useRef();
    const store = useStore({});
    const Host = opts2?.tagName ?? "qwik-react";
    const clientOnly = !!(props["client:only"] || opts2?.clientOnly);
    let eagerness;
    if (props["client:visible"] || opts2?.eagerness === "visible")
      eagerness = "visible";
    else if (props["client:load"] || clientOnly || opts2?.eagerness === "load")
      eagerness = "load";
    useWatchQrl(inlinedQrl(async ({ track }) => {
      const [props2, reactCmp$3, ref2, store2] = useLexicalScope();
      track(props2);
      const hostElement = ref2.current;
      if (isBrowser && hostElement) {
        if (store2.data)
          store2.data.root.render(store2.data.client.Main(store2.data.cmp, filterProps(props2)));
        else {
          const [Cmp, client] = await Promise.all([
            reactCmp$3.resolve(),
            import("./client.1abdbc9a.js")
          ]);
          let root;
          if (hostElement.childElementCount > 0)
            root = client.hydrateRoot(hostElement, client.Main(Cmp, filterProps(props2), store2.event));
          else {
            root = client.createRoot(hostElement);
            root.render(client.Main(Cmp, filterProps(props2)));
          }
          store2.data = noSerialize({
            client,
            cmp: Cmp,
            root
          });
        }
      }
    }, "qwikifyQrl_component_useWatch_x04JC5xeP1U", [
      props,
      reactCmp$2,
      ref,
      store
    ]), {
      eagerness
    });
    if (isServer && !clientOnly) {
      const jsx$1 = Promise.all([
        reactCmp$2.resolve(),
        import("./server.f07a53ac.js")
      ]).then(([Cmp, server]) => {
        const html = server.render(Cmp, filterProps(props));
        return /* @__PURE__ */ jsx(Host, {
          ref,
          dangerouslySetInnerHTML: html
        });
      });
      return /* @__PURE__ */ jsx(Fragment, {
        children: jsx$1
      });
    }
    return /* @__PURE__ */ jsx(Host, {
      ref,
      children: /* @__PURE__ */ jsx(SkipRerender, {})
    });
  }, "qwikifyQrl_component_zH94hIe0Ick", [
    opts,
    reactCmp$
  ]));
}
const filterProps = (props) => {
  const obj = {};
  Object.keys(props).forEach((key) => {
    if (!key.startsWith("client:"))
      obj[key] = props[key];
  });
  return obj;
};
const qwikify$ = /* @__PURE__ */ implicit$FirstArg(qwikifyQrl);
async function renderToString(rootNode, opts) {
  const mod = await import("./server.f07a53ac.js");
  const result = await mod.renderToString(rootNode, opts);
  const styles = mod.getGlobalStyleTag(result.html);
  const finalHtml = result.html.replace("</head>", styles + "</head>");
  return {
    ...result,
    html: finalHtml
  };
}
function qwikReact() {
  const OPTIMIZE_DEPS = [
    "react",
    "react-dom/client",
    "hoist-non-react-statics",
    "@emotion/react"
  ];
  const DEDUPE = [
    "react",
    "react-dom",
    "@emotion/react"
  ];
  return {
    name: "vite-plugin-qwik-react",
    config() {
      return {
        resolve: {
          dedupe: DEDUPE
        },
        optimizeDeps: {
          include: OPTIMIZE_DEPS
        }
      };
    }
  };
}
export {
  qwikReact,
  qwikify$,
  qwikifyQrl,
  renderToString
};
